'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _adapters = require('./adapters');

Object.keys(_adapters).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _adapters[key];
    }
  });
});

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _tymer = require('tymer');

var _tymer2 = _interopRequireDefault(_tymer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const dbg = (0, _debug2.default)('app:geocodr');

function retryFailedRequest(err) {
  if (err.status === 504 && err.config && !err.config.__isRetryRequest) {
    err.config.__isRetryRequest = true;
    return (0, _axios2.default)(err.config);
  }
  throw err;
}
_axios2.default.interceptors.response.use(undefined, retryFailedRequest);

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (address, { url, params, addressParam, parse, formatMulti, parseMulti }) {
    const timer = new _tymer2.default();
    let coordinates;
    let _address;
    let _coordinates;
    if (Array.isArray(address)) {
      _address = `${address[0]}...`;
      dbg('submitting batch=%o, size=%o, url=%o', _address, address.length, url);
      (0, _assert2.default)(formatMulti && parseMulti, 'formatMulti and parseMulti options required');
      const res = yield _axios2.default.post(url, formatMulti(address), { params });
      // dbg('geocode: res.data=%s', JSON.stringify(res.data, null, 2))
      coordinates = parseMulti(res.data);
      _coordinates = `[ ${coordinates[0]} ]...`;
    } else {
      _address = address;
      const res = yield _axios2.default.get(url, { params: Object.assign({}, params, { [addressParam]: address }) });
      coordinates = parse(res.data);
      _coordinates = coordinates;
    }

    dbg('address=%s, coordinates=%o, elapsed=%o', _address, _coordinates, timer.stop());

    return coordinates;
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();